Gammal.ib - Feature #599

Add spectral table model a la XSPEC
11/27/2012 02:47 PM - Knédlseder Jurgen

Status: Closed Start date:

Priority: High Due date:

Assigned To: Knédlseder Jurgen % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 1.7.0

Description

The XSPEC package allows spectral models to be defined using a FITS table. Code should be added to Gammalib to support this
format. This would then allow inclusion of XSPEC table models in Gammalib analyses.

See http://heasarc.gsfc.nasa.gov/docs/heasarc/ofwg/docs/general/ogip_92_009/ogip_92_009.html for more information on XSPEC

table models.

History

#1 - 11/27/2012 02:48 PM - Knddlseder Jiirgen
- Description updated

#2 - 12/11/2013 09:34 PM - Knodlseder Jiirgen

- Target version set to 2nd coding sprint

#3 - 02/17/2014 10:22 PM - Knodlseder Jiirgen

- Target version deleted (2nd coding sprint)

#4 - 07/08/2019 10:57 AM - Knddlseder Jiirgen
- Priority changed from Normal to High

- Target version set to 1.7.0

#5 - 11/25/2019 09:32 PM - Knddliseder Jiirgen
- Status changed from New to In Progress
- Assigned To set to Knddlseder Jiirgen

- % Done changed from 0 to 10

| added the classes GModelSpectralTablePar and GModelSpectralTablePars to handle table model parameters.

The class GModelSpectralTablePar implements a structure that combines a model parameter GModelPar with a list of values that represent the

values at which the parameter is evaluated.

The class GModelSpectralTablePars is a container class that combines the relevant parameters for a given table model.

#6 - 11/26/2019 02:53 PM - Knodlseder Jiirgen
- % Done changed from 10 to 30

| started implementing a GModelSpectralTable class that handles table model in the XSPEC format.

For the moment the class supports creating of table models, saving them into a FITS file and reloading the models from the FITS file.
http://heasarc.gsfc.nasa.gov/docs/heasarc/ofwg/docs/general/ogip_92_009/ogip_92_009.html

#7 - 06/23/2020 04:24 PM - Knodlseder Jiirgen
- File test.py added

- File Normalization_100_50_50.png added

- File Index_100_50_50.png added

- File Cutoff_100_50_50.png added

- % Done changed from 30 to 80

| completed the implementation of the GModelSpectralTable class. | did some tests using the following script: attachment:test.py. The script
generates a table model using an exponentially cutoff power law. The script generates spectral vectors with 50 energy bins for the energy range 10
GeV - 300 TeV. The spectral index is varied between -1 and -3 with a step size of 0.02, the cutoff energy is varied from 0.1 TeV to 28 TeV using a
logarithmic spacing. Note, however, that for the moment the parameters are interpolated linearly.

The script checks also the results of the flux and eflux methods:

Method GModelSpectralExpPlaw GModelSpectralTable
flux() 650290.728691 649713.700728
eflux() 262858.068641 262396.532449

Finally, | created a pull distribution with 1000 trials for the table model, below the normalisation, index and cutoff pull histograms.
#8 - 06/23/2020 06:05 PM - Knodlseder Jiirgen
- Status changed from In Progress to Closed

- % Done changed from 80 to 100

Merged into devel.
Files

test.py 3.93 KB 06/23/2020 Knédlseder Jirgen
Normalization_100_50_50.png 42 KB 06/23/2020 Knédlseder Jirgen
Index_100_50_50.png 39.4 KB 06/23/2020 Knédlseder Jirgen
Cutoff_100_50_50.png 39.9 KB 06/23/2020 Knédlseder Jirgen
